Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh	(revision 2720)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh	(revision 2721)
@@ -11,18 +11,20 @@
 echo "starting $TARGET version"
 
-#SCENE=../data/Arena/arena-high-lods.obj
-#VIEWCELLS=../data/Arena/arena-high-lods-5000-viewcells.xml.gz
+SCENE=../data/Arena/arena-high-lods.obj
+SCENE=../data/Arena/arena_trees.obj
+VIEWCELLS=../data/Arena/arena-high-lods-5000-viewcells.xml.gz
 #SCENE=../data/vienna/vienna_cropped.obj
 #SCENE=../data/roofs_new.obj
-SCENE=../data/vienna/city_full_hp.obj
+#SCENE=../data/vienna/city_full_hp.obj
 #SCENE=../data/vienna/vienna_rep.obj
 
 #SCENE=../data/vienna/vienna_cropped.obj
-VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz 
-VIEWPOINTS=../data/vienna/testwalk.vp
+#VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz 
+#VIEWPOINTS=../data/vienna/testwalk.vp
+VIEWPOINTS=../data/arena/arena_key.vp
 
 #LOG_PREFIX=../src/SG08/rebut-arena-pixel2
 #LOG_PREFIX=../src/SG08/full
-LOG_PREFIX=../src/SG08/city_full
+LOG_PREFIX=../src/SG08/arena_trees
 
 ENVIRONMENT=gvs.env
@@ -41,6 +43,6 @@
 -gvs_samples_per_pass=1000000 \
 -gvs_initial_samples=16 \
--gvs_max_viewcells=5000 \
--gvs_min_contribution=2000 \
+-gvs_max_viewcells=20000 \
+-gvs_min_contribution=4000 \
 -gvs_per_viewcell=true \
 -preprocessor_detect_empty_viewspace+ \
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2720)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2721)
@@ -247,5 +247,5 @@
 
 		// mat_specular and mat_shininess are NOT default values
-		GLfloat mat_ambient[] = {0.2f, 0.2f, 0.2f, 1.0f};
+		/*GLfloat mat_ambient[] = {0.2f, 0.2f, 0.2f, 1.0f};
 		GLfloat mat_diffuse[] = {1.0f, 1.0f, 1.0f, 1.0f};
 		GLfloat mat_specular[] = {0.3f, 0.3f, 0.3f, 1.0f};
@@ -256,8 +256,8 @@
 		glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
 		glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
+		*/
 
 		GLfloat light_ambient[] = {0.1, 0.1, 0.1, 1.0};
-		//GLfloat light_diffuse[] = {0.6, 0.6, 0.6, 1.0};
-		GLfloat light_diffuse[] = {0.5, 0.5, 0.5, 1.0};
+		GLfloat light_diffuse[] = {0.6, 0.6, 0.6, 1.0};
 		GLfloat light_specular[] = {1.0, 1.0, 1.0, 1.0};
 
@@ -266,5 +266,4 @@
 
 		// lights in arena
-		
 		glEnable(GL_LIGHT0); 
 
@@ -273,7 +272,4 @@
 		glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
 		glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
-
-		
-		
 		
 		glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
@@ -286,5 +282,5 @@
 	}
 
-	//glDisable(GL_ALPHA_TEST);
+	glDisable(GL_ALPHA_TEST);
 		
 	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
@@ -317,4 +313,6 @@
 
 	glEnable(GL_STENCIL_TEST); 
+
+	// errors in red
 	glColor3f(1, 0, 0);
 
@@ -342,5 +340,5 @@
 	pErrorPixels = (float)pixelCount / (GetWidth() * GetHeight());
 
-	const int pixelThres = 0;
+	const int pixelThres = -1;
 
 	// some error happened
@@ -355,4 +353,5 @@
 			//glReadBuffer(GL_FRONT);
 
+			cout << "here34" << endl;
 			//////////////
 			//-- output error visualization
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2719)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2721)
@@ -148,6 +148,6 @@
 		                                      mDetectEmptyViewSpace);
 
-	mSnapErrorFrames = false;
-	//mSnapErrorFrames = true;
+	//mSnapErrorFrames = false;
+	mSnapErrorFrames = true;
 
 	mSnapPrefix = "snap/";
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 2695)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 2721)
@@ -639,5 +639,10 @@
 
 	// hack for submission: enlarge by some margin
-	mViewSpaceBox.SetMax(1, mViewSpaceBox.Max().y + 40.0f);
+	if (0)
+	{
+		const float VIEWSPACE_OFFSET = 40.0f;
+		mViewSpaceBox.SetMax(1, mViewSpaceBox.Max().y + VIEWSPACE_OFFSET);
+	}
+
 	// create the hierarchy based on this information
 	CreateViewSpaceHierarchy();